#ifndef __ROINFOTABLE_HPP__
#define __ROINFOTABLE_HPP__

/*
	RoInfoTable.hpp
	RȌe[uBACeAEƁAʂȂǁB
*/

// CN[h
#include <windows.h>

// STL
#include <string>
#include <map>
using namespace std;

// O[oϐ
char *g_pszJob[25] = {
	"Novice",
	"Swordman",
	"Mage",
	"Archer",
	"Acolyte",
	"Merchant",
	"Thief",
	"Knight",
	"Priest",
	"Wizard",
	"Blacksmith",
	"Hunter",
	"Assassin",
	"-GM-",
	"Crusader",
	"Monk",
	"Sage",
	"Rogue",
	"Alchemist",
	"Bard",
	"Dancer",
	"UnknownJob", // Ȃ̂ŁB
	"Bride/Groom", // Ⴄł傤ǈꉞB
	"SuperNovice",
	"UnknownJob"
};

char *g_pszSex[3] = {
	"Girl",
	"Boy",
	"Unknown Sex"
};

map<WORD, string> g_mapItemTable;

/////////////////////////////////////////////////////////////

// WuԍWu
string GetJobString(WORD nType) 
{
	nType = min(nType, sizeof(g_pszJob) / sizeof(char*) - 1);
	return g_pszJob[nType];
}

// ʔԍ
string GetSexString(BYTE nSex)
{
	nSex = min(nSex, sizeof(g_pszSex) / sizeof(char*) - 1);
	return g_pszSex[nSex];
}

// e[u̓ǂݍ
bool LoadItemTable(char *pszFileName)
{
	char szBuf[128];
	char *pszTemp;
	WORD nItem;

	FILE *fp = fopen(pszFileName, "r");
	if (fp == NULL)
		return false;
		
	g_mapItemTable.clear();
	while(fgets(szBuf, sizeof(szBuf), fp) != NULL)
	{
		pszTemp = strchr(szBuf, '\n');
		if (pszTemp != NULL)
			*pszTemp = '\0';

		if (*szBuf == '#' || *szBuf == '\0')
			continue;

		nItem = (WORD)strtoul(szBuf, &pszTemp, 16);
		if (pszTemp != NULL)
			for(; isspace(*pszTemp); pszTemp++);

		g_mapItemTable[nItem] = pszTemp;
	}
	fclose(fp);
	return true;
}

// ACeԍACe
string GetItemName(WORD nItem)
{
	map<WORD, string>::iterator it;
	char szName[5];
	
	it = g_mapItemTable.find(nItem);
	if (it == g_mapItemTable.end())
	{
		sprintf(szName, "%04x", nItem);
		g_mapItemTable[nItem] = szName;
		return szName;
	}
	return it->second;
}

#endif // __ROINFOTABLE_HPP__
